--------------------------------------------------------
-- non_restoring division cell
-- Actually an adder-subtracter
--------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.mypackage.all;

entity nr_cell is
    port (
	 		a: in STD_LOGIC_VECTOR (MBITS downto 0);
			b: in STD_LOGIC_VECTOR (MBITS-1 downto 0);
			q: in STD_LOGIC;
			r: out STD_LOGIC_VECTOR (MBITS downto 0)
     );
end nr_cell;

architecture nr_cel_arch of nr_cell is

begin

adder_subtracter: process (q,a,b)
begin
	  if q = '1' then
			r <= a + b;
	  else
	 		r <= a - b;
	  end if; 
end process;


end nr_cel_arch;


